﻿using HighWayIot.Repository.domain;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HighWayIot.Repository.service
{
    public interface IStateService
    {

        /// <summary>
        /// 获取RFID状态列表
        /// </summary>
        /// <returns></returns>
        List<RFIDState>GetStateInfos();

        /// <summary>
        /// 新增一条状态
        /// </summary>
        /// <param name="content"></param>
        void AddStateInfo(RFIDState state);
    }
}
